import unittest
from conf.testing import czifile, ilastik, output_path
from model_server.image import CziImageFileAccessor, write_accessor_data_to_file
from model_server.ilastik import IlastikPixelClassifierModel

class TestIlastikPixelClassification(unittest.TestCase):
    def setUp(self) -> None:
        self.cf = CziImageFileAccessor(czifile['path'])

    # def tearDown(self) -> None:
    #     pass

    def test_faulthandler(self): # recreate error that is messing up ilastik
        import io
        import sys
        import faulthandler

        with self.assertRaises(io.UnsupportedOperation):
            faulthandler.enable(file=sys.stdout)

    def test_run_pixel_classifier(self):
        channel = 2
        model = IlastikPixelClassifierModel({'project_file': ilastik['pixel_classifier']})
        cf = CziImageFileAccessor(czifile['path'])
        pxmap = model.infer(cf.get_one_channel_data(channel))

        print(pxmap.shape_dict)

        # self.assertEqual(pxmap.shape[0:2], cf.shape[0:2])
        # self.assertEqual(pxmap.shape_dict['C'], 2)
        # self.assertEqual(pxmap.shape_dict['Z'], 1)
        #
        # self.assertTrue(
        #     write_accessor_data_to_file(
        #         output_path / f'pxmap_{cf.fpath.stem}_ch{channel}.tif',
        #         pxmap
        #     )
        # )